/*********************************************\
*   BeApple2 : Apple ][+ emulator for BeOS    *
*                                             *
*        tape.cpp : Cassette tape             *
\*********************************************/

// Quick & dirty implementation !

#include <MediaKit.h>
#include <stdio.h>
#include "cpu.h"
#include "tape.h"
#include "app.h"

bool TapeLec=false;
bool TapeEcr=false;

bool Look=false;

void *TapeBufIN=NULL;

BMediaTrack *bmtIN,*bmtOUT;
BMediaFile  *bmfIN,*bmfOUT;

int64 TapeCycles=0; // CPU cycle when the tape was loaded
float TapePos=0;
float TapeMax=0;

float Fe=44100;
int Last=0;

media_format MF;

//------------------------------------------

void pr(char *s,media_format *pMF)
{
 printf ("%s : Type =%i\n",s,pMF->type);

 if (pMF->type==B_MEDIA_RAW_AUDIO) {
 	printf ("%s : Raw Audio\n",s);
	printf ("%s : Frame_rate    =%f\n"  ,s,(float)pMF->u.raw_audio.frame_rate);
	printf ("%s : Channel count =%i\n"  ,s,(int)pMF->u.raw_audio.channel_count);
	printf ("%s : Format        =0x%X\n",s,(int)pMF->u.raw_audio.format);
	printf ("%s : Byte_order    =%i\n"  ,s,(int)pMF->u.raw_audio.byte_order);
	printf ("%s : Buffer_size   =%i\n"  ,s,(int)pMF->u.raw_audio.buffer_size);
	}
 if (pMF->type==B_MEDIA_ENCODED_AUDIO) {
 	printf ("%s : Encoded Audio\n",s);
	printf ("%s : Frame_rate    =%f\n"  ,s,(float)pMF->u.encoded_audio.output.frame_rate);
	printf ("%s : Channel count =%i\n"  ,s,(int)pMF->u.encoded_audio.output.channel_count);
	printf ("%s : Format        =0x%X\n",s,(int)pMF->u.encoded_audio.output.format);
	printf ("%s : Byte_order    =%i\n"  ,s,(int)pMF->u.encoded_audio.output.byte_order);
	printf ("%s : Buffer_size   =%i\n"  ,s,(int)pMF->u.encoded_audio.output.buffer_size);
 	printf ("%s : Bit rate =%f\n",s,(float)pMF->u.encoded_audio.bit_rate);
	}
}
//------------------------------------------

int OpenTape(entry_ref *ref)
{
 media_format mf;

 ClearTape();

 memset((void *)&mf, 0, sizeof(mf));
 memset((void *)&MF, 0, sizeof(MF));

 MF.type=B_MEDIA_RAW_AUDIO;
 MF.u.raw_audio = media_raw_audio_format::wildcard;
 MF.u.raw_audio.format=media_raw_audio_format::B_AUDIO_FLOAT;
 MF.u.raw_audio.frame_rate=44100.0;
 MF.u.raw_audio.channel_count=1;
 MF.u.raw_audio.byte_order=B_MEDIA_HOST_ENDIAN;
 MF.u.raw_audio.buffer_size=4096;

 bmfIN = new BMediaFile(ref);

 bool Trouve = false;
 int32 numTracks = bmfIN->CountTracks();

 for (int32 i = 0; i < numTracks; i++) {
	bmtIN = bmfIN->TrackAt(i);
	if (bmtIN == NULL) {
		return 1;
		}
	else {
		if (bmtIN->EncodedFormat(&mf) == B_NO_ERROR) {			
			switch (mf.type) {
				case B_MEDIA_RAW_AUDIO:
				case B_MEDIA_ENCODED_AUDIO:
					if (bmtIN->DecodedFormat(&MF) == B_NO_ERROR) Trouve=true;
					break;
				default:
					Trouve=false;
					break;
				}
			}
		if (Trouve) break;
		}
	}

 pr("mf",&mf);
 pr("MF",&MF);
 
 if (!Trouve) {
 	printf ("Non trouvé\n");
	bmfIN->ReleaseTrack(bmtIN);
	bmfIN=NULL;
	bmtIN=NULL;
	return 1;
	}
 Fe=mf.u.raw_audio.frame_rate;
 printf ("Fe=%f\n",Fe);
 bmtIN->InitCheck();
 float Flo=bmtIN->Duration();
 printf ("Durée=%f secondes\n",(float)(Flo/1E6));
 TapeCycles=SimCycles; TapeCycles+=FasCycles;
 TapePos=0;
 TapeMax=0;

 TapeBufIN=malloc(MF.u.raw_audio.buffer_size * (MF.u.raw_audio.format & 15)
 				* MF.u.raw_audio.channel_count);
 TapeLec=true;
 TapeLook();
 return 0;
}

//------------------------------------------
void InitTape()
{
 TapePos=0;
 TapeMax=0;
 TapeBufIN=NULL;
 bmfIN=NULL;
 bmtIN=NULL;
 TapeLec=false;
}

//------------------------------------------
void ClearTape()
{
 TapeLec=false;
 if (bmfIN) {
 	printf ("Clear\n");
	bmfIN->ReleaseTrack(bmtIN);
	delete (bmfIN);
	bmfIN=NULL;
	bmtIN=NULL;
	if (TapeBufIN) { free(TapeBufIN); TapeBufIN=NULL; }
	}
 TapeLec=false;	
 TapeLook();
}

//------------------------------------------
int ReadTape()
{
 int64 Count;
 
 if (!TapeLec) return 0;

 int64 Delta=SimCycles; Delta+=FasCycles;
 Delta-=TapeCycles;

 TapeCycles=SimCycles; TapeCycles+=FasCycles;

 float Lo=((float)Delta*(Fe/1000000.0))+TapePos;
 TapePos=Lo;

 while (TapePos>=TapeMax) {
	bmtIN->ReadFrames(TapeBufIN,&Count);
	TapeMax=Count;
	if (Count==0) {
		TapeLec=false;
		TapeLook();
		bmfIN->ReleaseTrack(bmtIN);
		delete(bmfIN);
		bmfIN=NULL;
		bmtIN=NULL;
		printf ("FINI\n");
		return 0;
		}
	TapePos-=TapeMax;
	}

 int Ret=0;
 int NV=MF.u.raw_audio.channel_count;
 if ((TapePos>=0)&&(TapePos<4096)) {
	float F=0;
	uint I=(uint)TapePos; I*=NV;
	switch (MF.u.raw_audio.format) {
		case media_raw_audio_format::B_AUDIO_FLOAT:
			F=((float *)TapeBufIN)[I];
			break;
		case media_raw_audio_format::B_AUDIO_INT:
			F=((int32 *)TapeBufIN)[I];
			F/=32768.0; F/=65536.0;
			break;
		case media_raw_audio_format::B_AUDIO_SHORT:
			F=((int16 *)TapeBufIN)[I];
			F/=32767.0;
			break;
		case media_raw_audio_format::B_AUDIO_UCHAR: 
			F=((uint8 *)TapeBufIN)[I];
			F-=128;
			F/=127;
			break;
		case media_raw_audio_format::B_AUDIO_CHAR:
			F=((int8 *)TapeBufIN)[I];
			F/=127;
			break; 	
		}
	Ret=(F>0)?128:0;
 	}
 return Ret;
}

//##############################################################

int SaveTape(entry_ref *ER)
{
 media_format	mfeOUT;
 memset(&mfeOUT, 0, sizeof(mfeOUT));
 mfeOUT.type=B_MEDIA_RAW_AUDIO;
 mfeOUT.u.raw_audio.format=media_raw_audio_format::B_AUDIO_SHORT;
 mfeOUT.u.raw_audio.frame_rate=44100.0;
 mfeOUT.u.raw_audio.channel_count=1;
 mfeOUT.u.raw_audio.byte_order=B_MEDIA_LITTLE_ENDIAN;
 mfeOUT.u.raw_audio.buffer_size=4096;

 media_file_format mfi;
 int32 cookie=0;
 while(get_next_file_format(&cookie, &mfi) == B_OK) {
	printf("%s (%s, id %d)\n", mfi.pretty_name,mfi.short_name, mfi.id);
	if (strcmp(mfi.short_name,"wav")==0) { printf ("Trouvé WAV <%s>\n",mfi.short_name); break; }
	}

 bmfOUT=new BMediaFile(ER,&mfi,B_MEDIA_FILE_REPLACE_MODE);
 if (bmfOUT==NULL) printf ("Erreur BMFOUT\n");
 status_t T=bmfOUT->InitCheck();
 printf ("T=%X ( %s)\n",(int)T,strerror(T));
 media_codec_info mci;
 media_format mf;
 cookie = 0;
 while (get_next_encoder(&cookie, &mfi, &mfeOUT,&mf, &mci) == B_OK) {
	printf("found encoder <%s> %s (%d)\n", mci.pretty_name,mci.short_name, mci.id);
	if (strcmp(mci.short_name,"raw-audio") == 0) { printf ("Trouvé RAW <%s>\n",mci.short_name); break; }
	}
 mfeOUT=mf;
 bmtOUT=bmfOUT->CreateTrack(&mfeOUT,&mci);

 if (bmfOUT->CommitHeader()!=B_OK) printf ("Erreur CommitHeader()\n");

 pr ("mfeOUT =",&mfeOUT);
 TapeEcr=true;
 TapeLook();
return 0;  //added return value (warning)
}

//------------------------------------------

int StopSaveTape()
{
 if (TapeEcr) {
	TapeEcr=false;
	bmfOUT->CloseFile();
	delete bmfOUT;
	}
 TapeLook();
 return 0;
}

//------------------------------------------

int WriteTape(float *Buf)
{
 if (TapeEcr) {
 	int16 Tmp[1024];
	for (uint16 I=0;I<1024;I++) Tmp[I]=(int16)(Buf[I]*32767.0);
	bmtOUT->WriteFrames(Tmp,1024);
	}
 return 0;
}

/*++++++++++++++++++++++++++++++++++++++++++
  +  TapeView                              +
  ++++++++++++++++++++++++++++++++++++++++++*/
BPoint Triangle[3];

TapeView::TapeView(BRect frame,const char *name) :BView(frame,name,B_FOLLOW_NONE,B_WILL_DRAW)
{
 SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
 Triangle[0]=BPoint(5,0);
 Triangle[1]=BPoint(15,5);
 Triangle[2]=BPoint(5,10);
}

//------------------------------------------

void TapeView::Draw(BRect brUp)
{
 BWindow *win=Window();
 win->Lock();
 BPolygon BP(Triangle,3);

 if (TapeLec) SetHighColor(0,255,0);
		else  SetHighColor(0,0,0);
 FillPolygon(&BP); 	
  	
 if (TapeEcr) SetHighColor(255,0,0);
 		else SetHighColor(0,0,0);
 FillRect(BRect(20,0,30,10));

 SetHighColor(255,255,255);
 StrokeLine(Triangle[0],Triangle[1]);
 StrokeLine(Triangle[0],Triangle[2]);
 StrokeLine(BPoint(20,0),BPoint(30,0));
 StrokeLine(BPoint(20,0),BPoint(20,10));
  
 SetHighColor(128,128,128);
 StrokeLine(Triangle[1],Triangle[2]);
 StrokeLine(BPoint(30,10),BPoint(30,0));
 StrokeLine(BPoint(30,10),BPoint(20,10));

 win->Unlock();
}


//------------------------------------------
void TapeLook()
{
 if (winAsim->Lock()) {
	winAsim->tvTape->Invalidate();
	winAsim->Unlock();
	}

}